# ==========算法中涉及的相关变量==========
# EnergyMode = {'极限节能': 1, '标准节能': 2, '安全节能': 3}  # 控制模式决定温度限制值，先写死，后续作为产品配置参数

# 在进行温湿度计算时，按照以下温度和湿度范围进行筛选，避免异常数据导致计算发生错误
TerminalTempRange = {'lowerLimit': 0, 'upperLimit': 50}
TerminalHumiRange = {'lowerLimit': 0, 'upperLimit': 100}

# 在进行温湿度限值修正时，用到以下阈值，先写死，后续视情况优化
ModifyTempHumiPara = {'threshold': 0.5, 'quantile': 0.75}  # 分别代表阈值和分位数

# 根据监测点情况进行水温计算时，用到以下系数，分别代表温度超标、湿度超标、露点超标、温度不超标、湿度不超标
Coefficient = {'outTemp': 1, 'outHumi': 0.1, 'outDewPoint': 1.25, 'inTemp': 0.5, 'inHumi': 0.05}

# 温湿度超标情况判断结果
ExcessDescription = {'0': '未超标', '1': '温度超标', '2': '露点超标', '3': '湿度超标'}

ExpectedStructure = {
        "terminalInfo": ["ahuMeterId", "ahuName", "ahuStartTime", "coolingTempUpper", "coolingHumiUpper", "tempReal",
                         "humiReal"],
        "controlConfigInfo": ["handleService", "controlMode", "isHardwareControl", "calPeriod", "minControlStep",
                              "chillerWaterTempSetInitial", "chillerWaterTempSetUpper", "chillerWaterTempSetLower",
                              "energyMode", "controlBasis", "tempMargin", "humiMargin", "mainTempMode", "samplePeriod",
                              "upTempControlPeriod", "downTempControlPeriod"],
        "chillerConfigInfo": ["waterTempControlMode", "isContinuousRun", "coolingShutdownOffset", "coolingRestartOffset",
                              "safetyPreDiffLowerLimit", "safetyLoadRatioLowerLimit", "chillerTempStep"],
        "chillerSafetyPara": ["circuitNumber", "circuitParameter"],
        "stationInfo": ["userName", "coolingStationName", "stationId", "runMode", "triggerTime",
                        "chilledWaterMainTempOut", "chilledWaterMainTempIn", "allChillersInfo"],
        "chillerInfo": ["chillerId", "chillerName", "capacityRated", "refriType", "chillerWaterTempSet",
                        "chillerOffTimeLatest", "offSetTempLatestCooling", "chillerWaterTempOut", "chillerWaterTempIn",
                        "runStatus", "chillerPowerRatio", "loadRate", "upControlTimeLatest", "downControlTimeLatest"],
    }
